Index: /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java	(revision 8971)
@@ -1199,130 +954,8 @@
                     
 		}
-
-		
 		name.setEnabled(true);
 		setVisible(true);
             }
-           /* else if (source == popupListener.menuAddAttributeAttribute){
-                System.out.println("add attr\n");
-                
-                name.setEnabled(true);
-                
-            }*/
-          /* else{
-		// Name combo box is enabled except when attributes are edited
-		//name.setEnabled((source != popupListener.menuEditValue));
-                //System.out.println("elsed");
-		name_to_values.clear();
-		name.clear();
-		value.clear();
-		value.setText("");
-		// Build the correct name_to_values mapping
-		// Attributes are slightly tricky as they can come from several sources. Has a collection file been selected...
-		if(current_collection_file != null) {
-		    target.setText(current_collection_file);
-		    // Name is empty in this one, however values must be the current elements in the collection.						  
-		    language_box.setEnabled(false);
-		}
-		// or has an element been selected
-		else if(current_element != null) {
-		    target.setText(current_element.toString());
-		    // Develop a model for name based on known attributes from all other elements.
-		    java.util.List elements = msm.getElements();
-		    for(int i = 0; i < elements.size(); i++) {
-			ElementWrapper element = (ElementWrapper) elements.get(i);
-			TreeSet attributes = element.getAttributes();
-			for(Iterator attribute_iterator = attributes.iterator(); attribute_iterator.hasNext(); ) {
-			    Attribute attribute = (Attribute) attribute_iterator.next();
-			    java.util.List values = (java.util.List) name_to_values.get(attribute.name);
-			    if(values == null) {
-				values = new ArrayList();
-				name_to_values.put(attribute.name, values);
-			    }
-			    if(!values.contains(attribute.value)) {
-				values.add(attribute.value);
-			    }
-			    values = null;
-			    attribute = null;
-			}
-			attributes = null;
-			element = null;
-		    }
-		    elements = null;
-		    language_box.setEnabled(true);
-		}
-		else if(current_set != null) {
-		    target.setText(current_set.toString());
-		    // Develop a model for name based on known attributes from all other metadata sets. At the same time build a hashmap mapping attribute name to lists of values.
-		    java.util.List sets = msm.getSets();
-		    for(int i = 0; i < sets.size(); i++) {
-			MetadataSet set = (MetadataSet) sets.get(i);
-			NamedNodeMap attributes = set.getAttributes();
-			for(int j = 0; j < attributes.getLength(); j++) {
-			    Attr attribute = (Attr) attributes.item(j);
-			    String name_str = attribute.getName();
-			    String value_str = attribute.getValue();
-			    java.util.List values = (java.util.List) name_to_values.get(name_str);
-			    if(values == null) {
-				values = new ArrayList();
-				name_to_values.put(name_str, values);
-			    }
-			    if(!values.contains(value_str)) {
-				values.add(value_str);
-			    }
-			    values = null;
-			    value_str = null;
-			    name_str = null;
-			    attribute = null;
-			}
-			attributes = null;
-			set = null;
-			language_box.setEnabled(false);
-		    }
-		    sets = null;
-		    // If this is an add remove all the attributes already present in the current set.
-		    if(source == add_attribute) {
-			name.setEnabled(true);
-			NamedNodeMap attributes = current_set.getAttributes();
-			for(int i = 0; i < attributes.getLength(); i++) {
-			    Attr attribute = (Attr) attributes.item(i);
-			    String name_str = attribute.getName();
-			    name_to_values.remove(name_str);
-			    name_str = null;
-			    attribute = null;
-			}
-			attributes = null;
-		    }
-		}
-		// Otherwise we actually disable the name combobox
-		else {
-		    name.setEnabled(false);
-		}
-		// Now name_to_values should contain a list of unique attribute names each mapping to a list of attribute values.
-		for(Iterator name_iterator = name_to_values.keySet().iterator(); name_iterator.hasNext(); ) {
-		    name.add(name_iterator.next());
-		}
-		// Now pritty up the dialog depending on the action type
-		if(source == add_attribute || source == popupListener.menuAddAttributeSet || source == popupListener.menuAddAttributeElement || source == popupListener.menuAddAttributeAttribute) {
-		    add_type = true;
-		    Dictionary.setText(this, "GEMS.AddAttribute");
-		    if(current_collection_file != null) {
-			// Name is empty in this one, however values must be the current elements in the collection.	
-			java.util.List values = msm.getElements();
-			for(int i = 0; i < values.size(); i++) {
-			    value.add(new NameElementWrapperEntry(values.get(i)));
-			}
-			values = null;
-		    }
-		    setVisible(true);
-		}*/
-               // else if(source == popupListener.menuAddAttributeAttribute){
-                    
-                //    System.out.println("fromattrib table");
-               // }
-               // else if(source == popupListener.menuAddAttributeElement){
-                    
-                 //   System.out.println("from elements");
-               // }*/
+           
 		else if(current_attribute != -1) {
 		    this.editAttribute();
@@ -1342,8 +975,4 @@
 	   //grab the table model based on what is currently selected
 	   switch(current_attribute_type) {
-	   case GEMSNode.COLLECTION:
-	       tablemodel = (AttributeTableModel) profile_attributes.getModel();
-	       
-	       break;
 	   case GEMSNode.SET:
 	       tablemodel = (AttributeTableModel) set_attributes.getModel();
@@ -1360,12 +989,4 @@
 	       
 	       break;
-	       
-	   case GEMSNode.SUBELEMENT:
-	       tablemodel = (AttributeTableModel) subelement_attributes.getModel();
-	       //grab values in table
-	       prevLang =  tablemodel.getValueAt(current_attribute,1).toString();
-	       prevValue = tablemodel.getValueAt(current_attribute,2).toString();
-	       break;
-	       
 	   default:
 	       //by default grab element_attr's
@@ -1407,15 +1028,7 @@
 	   
 	   switch(current_attribute_type) {
-	   case GEMSNode.COLLECTION:
-	       model = (AttributeTableModel) profile_attributes.getModel();
-	       break;
 	   case GEMSNode.ELEMENT:
 	       model = (AttributeTableModel) element_attributes.getModel();
 	       break;
-	       
-	   case GEMSNode.SUBELEMENT:
-	       model = (AttributeTableModel) subelement_attributes.getModel();
-	       break;
-	       
 	   case GEMSNode.SET:
 	       model = (AttributeTableModel) set_attributes.getModel();
@@ -1449,36 +1062,4 @@
        }
 
-       //Is this method ever used? What's a collection attribute? --Matthew
-	private boolean addOrEditCollectionAttribute(AttributeTableModel model)
-	{
-	    System.err.println("addOrEditCollectionAttribute was actually used!!"); //if this is ever used!!
-	    String name_str = name.getSelectedItem().toString();
-	    String value_str = Codec.transform(Codec.transformUnicode(value.getText()), Codec.TEXT_TO_DOM);
-
-	    // Remove the existing attribute if this is an edit
-	    if(!add_type && current_attribute != -1) {
-		String old_source = (String) model.getValueAt(current_attribute, 0);
-		old_source = null;
-		model.removeRow(current_attribute);
-	    }
-
-	    boolean cont = true;
-	    // Check that there isn't already an entry for this attribute
-	    if (!model.contains(name_str, 0)) {
-		// Update attribute table
-		model.add(new Attribute(name_str, value_str));
-	    }
-	    // Otherwise show an error message and do not proceed
-	    else {
-		cont = false;
-		JOptionPane.showMessageDialog(self, Dictionary.get("GEMS.Attribute_Already_Exists"), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-	    }
-
-	    value_str = null;
-	    name_str = null;
-	    return cont;
-	}
-
-
 	private boolean addOrEditSetAttribute(AttributeTableModel model)
 	{
@@ -1553,4 +1134,5 @@
 
 		    // Add the new attribute
+		    //System.err.println("current_element is: " + current_element.toString()); //debug
 		    current_element.addAttribute(new_name_str, language_code, value_str);
 		    // Update the attribute table
@@ -1571,156 +1153,17 @@
 	    return cont;
 	}
-       
-       //Very similar to addOrEditElementAttribute
-       private boolean addOrEditSubelementAttribute(AttributeTableModel model)
-       {
-	   String new_name_str = name.getSelectedItem().toString();
-	   String old_name_str = null;
-	   String language_code = (String) language_box.getSelectedItem();
-	   String value_str = Codec.transform(Codec.transformUnicode(value.getText()), Codec.TEXT_TO_DOM);
-	   String old_value_str = null;
-	   String old_lang_code = null;
-	   boolean edit = false;
-	   boolean cont = false;
-
-	   if(!add_type && current_attribute != -1) //An edit
-	       {
-		   Attribute old_attribute = model.getAttribute(current_attribute);
-		   old_value_str = old_attribute.value;
-		   old_lang_code = old_attribute.language;
-		   old_name_str = (String) subelement_attributes.getValueAt(current_attribute, 0); //get the old name.
-		   edit = true;
-	       }
-	   
-	   //Check that there isn't already an entry for this attribute
-	   if (!model.contains(new_name_str, 0) || (edit && new_name_str.equals(old_name_str)))
-	       {
-		    if(edit) //If this is an edit, remove the old attribute
-			{
-			    current_subelement.removeAttribute(old_name_str, old_lang_code, old_value_str);
-			    model.removeRow(current_attribute);
-			}
-
-		   // Add the new attribute
-		   current_subelement.addAttribute(new_name_str, language_code, value_str);
-		   // Update the attribute table
-		   int row = model.add(new Attribute(new_name_str, language_code, value_str));
-		   subelement_attributes.setRowSelectionInterval(row, row);
-		   cont = true;
-	       }
-	   // Otherwise show an error message and do not proceed
-	   else
-	       {
-		   cont = false;
-		   JOptionPane.showMessageDialog(self, Dictionary.get("GEMS.Attribute_Already_Exists"), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-	       } 
-	   
-	   value_str = null;
-	   language_code = null;
-	   new_name_str = null;
-	   return cont;
-       }
-
-
-	public void dispose() {
-	    cancel_button = null;
-	    name = null;
-	    name_to_values = null;
-	    ok_button = null;
-	    target = null;
-	    value = null;
-	    super.dispose();
-	}
     }
 
-
-    private class AddSubelementActionListener extends ModalDialog implements ActionListener {
-	private JButton cancel_button = null;
-	private JButton ok_button = null;
-	private JLabel element_field = null;
-	private NonWhitespaceField name_field = null;
+   
+    private class AddSubelementActionListener extends AddElementActionListener implements ActionListener {
 
 	public AddSubelementActionListener() {
-	    super(self);
-	    setModal(true);
-	    setSize(ADD_ELEMENT_SIZE);
-	    // Creation
-	    JPanel content_pane = (JPanel) getContentPane();
-	    content_pane.setBackground(config.getColor("coloring.collection_heading_background", false));
-	    JPanel center_pane = new JPanel();
-	    center_pane.setOpaque(false);
 	    Dictionary.setText(this, "GEMS.Popup.menuAddSubelement");
-
-	    JPanel labels_pane = new JPanel();
-	    labels_pane.setOpaque(false);
-	    JLabel element_label = new JLabel();
-	    element_label.setOpaque(false);
-	    Dictionary.setText(element_label, "GEMS.Element");
-	    element_field = new JLabel();
-	    element_field.setOpaque(false);
-
-	    JPanel values_pane = new JPanel();
-	    values_pane.setOpaque(false);
-	    JLabel name_label = new JLabel();
-	    name_label.setOpaque(false);
-	    Dictionary.setText(name_label, "GEMS.Name");
-	    name_field = new NonWhitespaceField();
-	    name_field.setBackground(config.getColor("coloring.collection_tree_background", false));
-	    name_field.setForeground(config.getColor("coloring.collection_tree_foreground", false));
-	    name_field.setSelectionColor(config.getColor("coloring.collection_selection_background", false));
-	    name_field.setSelectedTextColor(config.getColor("coloring.collection_selection_foreground", false));
 	    Dictionary.setTooltip(name_field, "GEMS.Subelement_Name_Tooltip");
-
-	    JPanel button_pane = new JPanel();
-	    button_pane.setOpaque(false);
-
-	    ok_button = new GLIButton();
-	    ok_button.setMnemonic(KeyEvent.VK_O);
-	    getRootPane().setDefaultButton(ok_button);
-	    Dictionary.setBoth(ok_button, "General.OK", "General.OK_Tooltip");
-	    cancel_button = new GLIButton();
-	    cancel_button.setMnemonic(KeyEvent.VK_C);
-	    Dictionary.setBoth(cancel_button, "General.Cancel", "General.Pure_Cancel_Tooltip");
-
-	    TextFieldEnabler ok_button_enabler = new TextFieldEnabler(ok_button);
-
-	    // Connection
-	    cancel_button.addActionListener(this);
-	    ok_button.addActionListener(this);
-	    ok_button_enabler.add(name_field);
-
-	    // Layout
-	    labels_pane.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
-	    labels_pane.setLayout(new GridLayout(2,1));
-	    labels_pane.add(element_label);
-	    labels_pane.add(name_label);
-
-	    values_pane.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
-	    values_pane.setLayout(new GridLayout(2,1));
-	    values_pane.add(element_field);
-	    values_pane.add(name_field);
-
-	    center_pane.setLayout(new BorderLayout(5,5));
-	    center_pane.add(labels_pane, BorderLayout.WEST);
-	    center_pane.add(values_pane, BorderLayout.CENTER);
-
-	    button_pane.setLayout(new GridLayout(1,2,0,5));
-	    button_pane.add(ok_button);
-	    button_pane.add(cancel_button);
-
-	    content_pane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
-	    content_pane.setLayout(new BorderLayout());
-	    content_pane.add(center_pane, BorderLayout.CENTER);
-	    content_pane.add(button_pane, BorderLayout.SOUTH);
-
-	    //use size of Add Element dialog
-	    setLocation((config.screen_size.width - ADD_ELEMENT_SIZE.width) / 2, (config.screen_size.height - ADD_ELEMENT_SIZE.height) / 2);
 	}
 
 	public void actionPerformed(ActionEvent event)
 	{
-	    //System.err.println("You chose to add a new subelement!!\n"); //debug
 	    Object source = event.getSource();
-	    GEMSNode new_node = null;
 	    current_element = current_node.getElement(); //current_element here is used generically for a element or subelement.
 
@@ -1728,7 +1171,5 @@
 		{
 		    String name_str = Codec.transform(Codec.transformUnicode(name_field.getText()), Codec.TEXT_TO_DOM);
-		    
 		    current_set = msm.getSet(current_element.getNamespace());
-		    //System.err.println("current_element.getNamespace(): " + current_element.getNamespace()); //debug
 		    if(current_set != null)
 			{
@@ -1740,9 +1181,13 @@
 				    ElementWrapper subelement = current_set.addElement(name_str, language_code, current_node);
 
-				    // Then update the tree
-				    new_node = model.add(current_node, subelement, GEMSNode.SUBELEMENT);
-				    //Expand element so can see subelement.
-				    mds_tree.expandPath(new TreePath(current_node.getPath()));
-				    //Would like to select new subelement, but this doesn't seem to work.
+				    final GEMSNode new_node = model.add(current_node, subelement, GEMSNode.ELEMENT); //Then update the tree.
+				   
+				    //SwingUtilities.invokeLater is used so that expandPath works on new parents.
+				    SwingUtilities.invokeLater(new Runnable() {
+					    public void run() {
+						mds_tree.expandPath(new TreePath(current_node.getPath())); //Expand element so can see subelement.
+						mds_tree.getSelectionModel().setSelectionPath(new TreePath(new_node)); //works, but node on tree doesn't look hilighted!!
+					    }
+					});
 
 				    //Done. Finish up.
@@ -1769,5 +1214,5 @@
 	    else
 		{
-		    element_field.setText(current_node.toString()); //set to the name of the element
+		    set_field.setText(current_node.toString()); //set to the name of the subelement
 		    name_field.setText("");
 		    setVisible(true);
@@ -1780,5 +1225,5 @@
 	    ok_button = null;
 	    name_field = null;
-	    element_field = null;
+	    set_field = null;
 	    super.dispose();
 	}
@@ -1789,8 +1234,8 @@
 	extends ModalDialog
 	implements ActionListener {
-	private JButton cancel_button = null;
-	private JButton ok_button = null;
-	private JLabel set_field = null;
-	private NonWhitespaceField name_field = null;
+	protected JButton cancel_button = null;
+	protected JButton ok_button = null;
+	protected JLabel set_field = null;
+	protected NonWhitespaceField name_field = null;
 	public AddElementActionListener() {
 	    super(self);
@@ -1882,8 +1327,14 @@
 		    String language_code = config.getLanguage();
 		    ElementWrapper element = current_set.addElement(name_str, language_code, null);
+
 		    // Then update the tree
 		    model.add(current_node, element, GEMSNode.ELEMENT);
-		    mds_tree.expandPath(new TreePath(current_node.getPath())); //expand set.
-
+		    //SwingUtilities.invokeLater is used so that expandPath works on new parents.
+		    SwingUtilities.invokeLater(new Runnable() {
+			    public void run() {
+				mds_tree.expandPath(new TreePath(current_node.getPath())); //expand set.
+			    }
+			});
+		    
 		    // Done
 		    element = null;
@@ -1929,124 +1380,9 @@
 	    name_field = null;
 	    set_field = null;
-	    ///ystem.err.println("Dispose AddElementActionListener");
 	    super.dispose();
 	}
     }
 	 
-    private class AddFileActionListener
-	extends ModalDialog
-	implements ActionListener {
-	private JButton cancel_button = null;
-	private JButton ok_button = null;
-	private JTextField name_field = null;
-	public AddFileActionListener() {
-	    super(self);
-	    setModal(true);
-	    setSize(ADD_FILE_SIZE);
-	    // Creation
-	    JPanel content_pane = (JPanel) getContentPane();
-	    content_pane.setBackground(config.getColor("coloring.collection_heading_background", false));
-	    JPanel center_pane = new JPanel();
-	    center_pane.setOpaque(false);
-	    JPanel profile_pane = new JPanel();
-	    profile_pane.setOpaque(false);
-	    JLabel profile_label = new JLabel();
-	    profile_label.setOpaque(false);
-	    Dictionary.setText(profile_label, "GEMS.Profile");
-
-	    JPanel name_pane = new JPanel();
-	    name_pane.setOpaque(false);
-	    JLabel name_label = new JLabel();
-	    name_label.setOpaque(false);
-	    Dictionary.setText(name_label, "GEMS.Name");
-	    name_field = new JTextField();
-	    name_field.setBackground(config.getColor("coloring.collection_tree_background", false));
-	    name_field.setForeground(config.getColor("coloring.collection_tree_foreground", false));
-	    name_field.setSelectionColor(config.getColor("coloring.collection_selection_background", false));
-	    name_field.setSelectedTextColor(config.getColor("coloring.collection_selection_foreground", false));
-	    Dictionary.setTooltip(name_field, "GEMS.Profile_Name_Tooltip"); 
-
-	    JPanel button_pane = new JPanel();
-	    button_pane.setOpaque(false);
-
-	    ok_button = new GLIButton();
-	    ok_button.setMnemonic(KeyEvent.VK_O);
-	    Dictionary.setBoth(ok_button, "General.OK", "General.OK_Tooltip");
-	    cancel_button = new GLIButton();
-	    cancel_button.setMnemonic(KeyEvent.VK_C);
-	    Dictionary.setBoth(cancel_button, "General.Cancel", "General.Pure_Cancel_Tooltip");
-
-	    TextFieldEnabler ok_button_enabler = new TextFieldEnabler(ok_button);
-
-	    // Connection
-	    cancel_button.addActionListener(this);
-	    ok_button.addActionListener(this);
-	    ok_button_enabler.add(name_field);
-
-	    // Layout
-	    profile_pane.setBorder(BorderFactory.createEmptyBorder(0,0,5,0));
-	    profile_pane.setLayout(new BorderLayout());
-	    profile_pane.add(profile_label, BorderLayout.CENTER);
-
-	    name_pane.setBorder(BorderFactory.createEmptyBorder(0,0,5,5));
-	    name_pane.setLayout(new BorderLayout(5,0));
-	    name_pane.add(name_label, BorderLayout.WEST);
-	    name_pane.add(name_field, BorderLayout.CENTER);
-
-	    center_pane.setLayout(new GridLayout(2,1,0,0));
-	    center_pane.add(profile_pane);
-	    center_pane.add(name_pane);
-
-	    button_pane.setLayout(new GridLayout(1,2,0,5));
-	    button_pane.add(ok_button);
-	    button_pane.add(cancel_button);
-
-	    content_pane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
-	    content_pane.setLayout(new BorderLayout());
-	    content_pane.add(center_pane, BorderLayout.CENTER);
-	    content_pane.add(button_pane, BorderLayout.SOUTH);
-
-	    setLocation((config.screen_size.width - ADD_FILE_SIZE.width) / 2, (config.screen_size.height - ADD_FILE_SIZE.height) / 2);
-	}
-	/** Any implementation of ActionListener must include this method so that we can be informed when an action as occured on our registered component, allowing us to
-	 * @param event An <strong>ActionEvent</strong> containing information about the event.
-	 */
-	public void actionPerformed(ActionEvent event) {
-	    Object source = event.getSource();
-	    if(source == ok_button) {
-		String name_str = Codec.transform(Codec.transformUnicode(name_field.getText()), Codec.TEXT_TO_DOM);
-		// Ensure that this source doesn't already exist.
-// 		if(!msm.profiler.containsSource(name_str)) {
-// 		    // Add source with empty hashmap of actions.
-// 		    msm.profiler.addSource(name_str);
-// 		    // Add to tree
-// 		    model.add(model.getProfileNode(), name_str, GEMSNode.COLLECTION);
-// 		    setVisible(false);
-// 		}
-		// Otherwise warn the user and don't hide the prompt.
-		// else {
-		JOptionPane.showMessageDialog(self, Dictionary.get("GEMS.File_Already_Exists"), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-		// }
-		name_str = null;
-	    }
-	    else if(source == cancel_button) {
-		setVisible(false);
-	    }
-	    else {
-		name_field.setText("");
-		setVisible(true);
-	    }
-	    source = null;
-	}
-
-	public void dispose() {
-	    cancel_button = null;
-	    ok_button = null;
-	    name_field = null;
-	    ///ystem.err.println("Dispose AddFileActionListener");
-	    super.dispose();
-	}
-    }
-
+   
     private class AddSetActionListener
 	extends ModalDialog
@@ -2135,5 +1471,4 @@
             //add sets to existingSetJComboBox
             
-            //String tempstr = new String();
             JLabel dummyl = new JLabel();
             Dictionary.setText(dummyl, "GEMS.Add_Set.No_Inherit");
@@ -2180,6 +1515,4 @@
 	    Object source = event.getSource();
             
-            
-          // if(a_set_exists_with_this_namespace(namespace_field.getText()) == false){
 	    if(source == ok_button) {
                 //this code below handles whether we inherit from an existing set or not
@@ -2289,5 +1622,4 @@
 	    ok_button = null;
 	    name_field = null;
-	    ///ystem.err.println("Dispose AddSetActionListener");
 	    super.dispose();
 	}
@@ -2327,5 +1659,5 @@
 	    cancel_button.setMnemonic(KeyEvent.VK_C);
 	    Dictionary.setBoth(cancel_button, "General.Cancel", "General.Pure_Cancel_Tooltip");
-	    TextFieldEnabler ok_button_enabler = new TextFieldEnabler(ok_button);
+	    //TextFieldEnabler ok_button_enabler = new TextFieldEnabler(ok_button);
 
 	    // Connection
@@ -2339,6 +1671,4 @@
             Dictionary.setText(inheritJLabel, "GEMS.inheritMetadataSet");
 	   
-            int getSetsLen = msm.getSets().toArray().length;
-            Vector theSets = msm.getSets();
             File[] col_dir = new File(Configuration.gsdl_path + "/collect").listFiles();
             
@@ -2358,5 +1688,4 @@
             
             existingSetJComboBox.setSelectedIndex(0);
-            //String tempstr = new String();
             JLabel dummyl = new JLabel();
             Dictionary.setText(dummyl, "GEMS.Add_Set.No_Inherit");
@@ -2416,5 +1745,4 @@
 	    }
 	    else {
-		//name_field.setText("");
 		setVisible(true);
 	    }
@@ -2427,28 +1755,8 @@
 	}
     }
-    
-
-
-    /** This listener is responsible for keeping the root node of a value tree expanded where and when possible. */
-    private class KeepTreeRootExpandedListener
-	implements TreeModelListener {
-	/** Invoked after a node (or a set of siblings) has changed in some way. */
-	public void treeNodesChanged(TreeModelEvent e) {
-	}
-        /** Invoked after nodes have been inserted into the tree. */
-	public void treeNodesInserted(TreeModelEvent e) {
-	    //  if(element_values != null && element_values.getModel() != null && element_values.getModel().getRoot() != null) {
-	    //	element_values.expandPath(new TreePath(element_values.getModel().getRoot()));
-	    //  }
-	}
-	/** Invoked after nodes have been removed from the tree. */
-	public void treeNodesRemoved(TreeModelEvent e) {
-	}
-	/** Invoked after the tree has drastically changed structure from a given node down. */
-	public void treeStructureChanged(TreeModelEvent e) {
-	    // element_values.expandPath(new TreePath(element_values.getModel().getRoot()));
-	} 
-    }
-
+
+    /*
+      Class to handle removing set or element attributes.
+    */
     private class RemoveAttributeActionListener
 	implements ActionListener, KeyListener {
@@ -2457,4 +1765,5 @@
 	   Any implementation of KeyListener must include these mothods.
 	   When the DELETE key is pressed, fire the actionPerformed event.
+	   @param e A <strong>KeyEvent</strong> containing information about the event.
 	*/
 	public void keyTyped(KeyEvent e){
@@ -2466,5 +1775,5 @@
 			{
 			    //DELETE key pressed
-			    actionPerformed((ActionEvent)null);
+			    actionPerformed((ActionEvent)null); //is there a better way?
 			}
 		}
@@ -2482,16 +1791,7 @@
 		if(result == 0) {
 		    ignore = true;
-		    // Attributes are tricky little beasties, as they can come from several different places and depend upon what other little beasties have been selected
-		    // Has a collection file been selected...
-		    if(current_collection_file != null) {
-			// Remove a profile
-			String source = (String) profile_attributes.getValueAt(current_attribute, 0);
-			// !!! msm.profiler.removeAction(current_collection_file, source);
-			source = null;
-			// Refresh table
-			((AttributeTableModel)profile_attributes.getModel()).removeRow(current_attribute);
-		    }
-		    // or has an element been selected
-		    else if(current_element != null) {
+		    //Attributes are tricky little beasties, as they can come from several different places and depend upon what other little beasties have been selected
+		    //Has an element been selected
+		    if(current_element != null) {
 			// Remove element attribute
 			String name = (String) element_attributes.getValueAt(current_attribute, 0);
@@ -2510,18 +1810,7 @@
 			((AttributeTableModel)set_attributes.getModel()).removeRow(current_attribute);
 		    }
-		    else if(current_subelement != null)
-			{
-			    //Remove subelement attribute
-			    String name = (String)subelement_attributes.getValueAt(current_attribute, 0);
-			    String language = (String) subelement_attributes.getValueAt(current_attribute, 1);
-			    String value = (String) subelement_attributes.getValueAt(current_attribute, 2);
-			    current_subelement.removeAttribute(name, language, value);
-
-			    //Refresh table
-			    ((AttributeTableModel)subelement_attributes.getModel()).removeRow(current_attribute);
-			}
 		    ignore = false;
                     
-                     atLeastOneSetChanged= true;
+		    atLeastOneSetChanged= true;
 		}
 	    }
@@ -2533,46 +1822,9 @@
     }
 
-    /**
-       Class to handle deletion of subelements.
-       This class can be created from either PopupHandler or KeyPressedHandler. KeyPressedHandler passes a null ActionEvent!!
-       @author: Matthew Whyte
-       @Date last modified: 18/01/05
-                            25/01/05
-    */
-    private class RemoveSubelementActionListener implements ActionListener {
-	/** Any implementation of ActionListener must include this method so that we can be informed when an action as occured on our registered component, allowing us to provide an editing prompt.
-	 * @param event An <strong>ActionEvent</strong> containing information about the event.
-	 */
-	public void actionPerformed(ActionEvent event)
-	{
-	    if(current_subelement != null)
-		{
-		    int result = JOptionPane.showOptionDialog(self, Dictionary.get("GEMS.Confirm_Removal", Dictionary.get("GEMS.Subelement")), Dictionary.get("GEMS.Confirm_Removal_Title"), JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, dialog_options, dialog_options[0]);
-		    if(result ==0) //Continue with remove
-			{
-			    TreeNode selPath = current_node.getParent();
-			    GEMSNode parent = (GEMSNode)selPath;
-			    current_element = parent.getElement();
-
-			    ignore = true;
-			    msm.removeElement(current_subelement, current_element); //remove the subelement.
-
-			    // Clear selection
-			    mds_tree.clearSelection();
-			    model.remove(current_node); //This is the new way of doing things :-) 
-			    card_layout.show(details_pane, BLANK); //Show a blank panel.
-			    ignore = false;
-			    
-			    atLeastOneSetChanged = true;
-			}
-		}
-	    else
-		{
-		    System.err.println("No subelement is selected."); //This should not happen
-		}
-	}
-
-    }
-
+    /*
+      Class to handle deletion of elements (including subelements).
+
+      Last modified 2/02/05 by Matthew Whyte
+     */
     private class RemoveElementActionListener
 	implements ActionListener {
@@ -2587,13 +1839,14 @@
 		// Remove this attribute
 		if(result == 0) {
+		    //Get the parent element
+		    GEMSNode parent_node = (GEMSNode)current_node.getParent();
+		    ElementWrapper parent_wrapped = parent_node.getElement();
+
 		    ignore = true;
-		    //System.err.println("Current element's getElement: " + current_element.getElement()); //Debug
-		    msm.removeElement(current_element, null);
+		    msm.removeElement(current_element, parent_wrapped);
 		    // Clear selection
 		    mds_tree.clearSelection();
-		    model.remove(current_element.getName(), GEMSNode.ELEMENT); //Need to use .getName() not .toString!!
-
-		    // Meanwhile disable/enable controls given we had an element selected, but no longer do.
-		    //remove_element.setEnabled(false);
+		    model.remove(current_node);
+
 		    // Show a blank panel.
 		    card_layout.show(details_pane, BLANK);
@@ -2604,34 +1857,8 @@
 	    }
 	    else {
-		///ystem.err.println("No current element selected.");
+		System.err.println("No element currently selected."); //This should not happen!
 	    }
 	}
     }
-
- 
-
-
-    private class RemoveFileActionListener
-	implements ActionListener {
-	/** Any implementation of ActionListener must include this method so that we can be informed when an action as occured on our registered component, allowing us to provide an editing prompt.
-	 * @param event An <strong>ActionEvent</strong> containing information about the event.
-	 */
-	public void actionPerformed(ActionEvent event) {
-	    if(current_collection_file != null) {
-		int result = JOptionPane.showOptionDialog(self, Dictionary.get("GEMS.Confirm_Removal", Dictionary.get("GEMS.File")), Dictionary.get("GEMS.Confirm_Removal_Title"), JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, dialog_options, dialog_options[0]);
-		// Remove the current collection file profile from the profiler.
-		if(result == 0) {
-		    ignore = true;
- 
-		    // Clear selection
-		    mds_tree.clearSelection();
-		    model.remove(current_collection_file, GEMSNode.COLLECTION);
-		    card_layout.show(details_pane, BLANK); //Show a blank panel.
-		    ignore = false;
-		}
-	    }
-	}
-    }
-
 
 
@@ -2639,5 +1866,5 @@
        Class to handle renaming of a set and/or it's namespace.
 
-       Author: Matthew Whyte
+       @author: Matthew Whyte
        Date last modified: 10/01/05
     */
